//#include <oratypes.h>
//#include <ociapr.h>
//#include <ocidem.h>

/*
 * definitions
 */

#define APP_VERSION		0.31

#define MAX_STATEMENT		4048
#define MAX_USERNAME		32
#define MAX_PASSWORD		32
#define MAX_BINDS               64
#define MAX_ITEM_BUFFER_SIZE    128
#define MAX_SELECT_LIST_SIZE    64
#define MAX_CFG_COLS		4
#define MAX_CFG_VALUE		128
#define MAX_CFG_LINE		256
#define PARSE_DEFERRED		0
#define V7_BEHAVIOR		2
#define NUMBER_WIDTH		8
#define MODE_TABLE		0
#define MODE_BY_ROW		1
#define MODE_BY_COL		2

/*
 * structures
 */

typedef struct
{
	sb4 dbsize;
	sb2 dbtype;
	sb1 buf[MAX_ITEM_BUFFER_SIZE];
	sb4 buflen;
	sb4 dsize;
	sb2 prec;
	sb2 scale;
	sb2 nullok;
} DescribeStruct;

typedef struct
{
	ub1 buf[MAX_ITEM_BUFFER_SIZE];
	float flt_buf;
	sword int_buf;
	sb2 indp;
	ub2 col_retlen;
	ub2 col_retcode;
} DefineStruct;

typedef struct {
	char username[MAX_USERNAME];
	char password[MAX_PASSWORD];
	sword display_mode_tty;
	sword display_mode_notty;
	sword display_col_names_tty;
	sword display_col_names_notty;
	sword cache_results;
} ConfigStruct;

/*
 * functions
 */

// config.c
void open_config (void);
void display_env (void);

// db.c
sword logon (void);
void logoff (void);
sword open_cursor (void);
void close_cursor (void);
void close_db (void);
void handle_error (Cda_Def *cda);
void main_loop (void);
void display_data_table (Cda_Def *cda, sword ncols);
void display_data_by_col (Cda_Def *cda, sword ncols);
void display_data_by_row (Cda_Def *cda, sword ncols);
void display_cache_data_table (Cda_Def *cda, long nrows, sword ncols);
void display_cache_data_by_col (Cda_Def *cda, long nrows, sword ncols);
void display_cache_data_by_row (Cda_Def *cda, long nrows, sword ncols);
sword get_sql_statement (void);
sword describe_define (Cda_Def *cda);
sword exec_sql (void);
void free_cache (long nrows, sword ncols);

// fsql.c
char *my_readline (char *prompt);

// misc.c
void display_online_help (void);
